#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cngeoip.h"


char *countries_rus[] = {
    "AU", "Австралия",
    "AT", "Австрия",
    "AZ", "Азербайджан",
    "AX", "Аландские острова",
    "AL", "Албания",
    "DZ", "Алжир",
    "UM", "Внешние малые острова (США)",
    "VI", "Американские Виргинские острова",
    "AS", "Американское Самоа",
    "AI", "Ангилья",
    "AO", "Ангола",
    "AD", "Андорра",
    "AQ", "Антарктида",
    "AG", "Антигуа и Барбуда",
    "AR", "Аргентина",
    "AM", "Армения",
    "AW", "Аруба",
    "AF", "Афганистан",
    "BS", "Багамы",
    "BD", "Бангладеш",
    "BB", "Барбадос",
    "BH", "Бахрейн",
    "BZ", "Белиз",
    "BY", "Белоруссия",
    "BE", "Бельгия",
    "BJ", "Бенин",
    "BM", "Бермуды",
    "BG", "Болгария",
    "BO", "Боливия",
    "BA", "Босния и Герцеговина",
    "BW", "Ботсвана",
    "BR", "Бразилия",
    "IO", "Британские территории Индийского океана",
    "VG", "Британские Виргинские острова",
    "BN", "Бруней",
    "BF", "Буркина Фасо",
    "BI", "Бурунди",
    "BT", "Бутан",
    "VU", "Вануату",
    "VA", "Ватикан",
    "GB", "Великобритания",
    "HU", "Венгрия",
    "VE", "Венесуэла",
    "TL", "Восточный Тимор",
    "VN", "Вьетнам",
    "GA", "Габон",
    "HT", "Гаити",
    "GY", "Гайана",
    "GM", "Гамбия",
    "GH", "Гана",
    "GP", "Гваделупа",
    "GT", "Гватемала",
    "GN", "Гвинея",
    "GW", "Гвинея-Бисау",
    "DE", "Германия",
    "GI", "Гибралтар",
    "HN", "Гондурас",
    "HK", "Гонконг",
    "GD", "Гренада",
    "GL", "Гренландия",
    "GR", "Греция",
    "GE", "Грузия",
    "GU", "Гуам",
    "DK", "Дания",
    "CD", "Демократическая Республика Конго",
    "DJ", "Джибути",
    "DM", "Доминика",
    "DO", "Доминиканская республика",
    "EU", "Европейский Союз",
    "EG", "Египет",
    "ZM", "Замбия",
    "EH", "Западная Сахара",
    "ZW", "Зимбабве",
    "IL", "Израиль",
    "IN", "Индия",
    "ID", "Индонезия",
    "JO", "Иордания",
    "IQ", "Ирак",
    "IR", "Иран",
    "IE", "Ирландия",
    "IS", "Исландия",
    "ES", "Испания",
    "IT", "Италия",
    "YE", "Йемен",
    "KP", "КНДР",
    "CV", "Кабо-Верде",
    "KZ", "Казахстан",
    "KY", "Каймановы острова",
    "KH", "Камбоджа",
    "CM", "Камерун",
    "CA", "Канада",
    "QA", "Катар",
    "KE", "Кения",
    "CY", "Кипр",
    "KG", "Киргизстан",
    "KI", "Кирибати",
    "CN", "Китайская Народная Республика",
    "CC", "Кокосовые острова",
    "CO", "Колумбия",
    "KM", "Коморские острова",
    "CR", "Коста-Рика",
    "CI", "Кот-д’Ивуар",
    "CU", "Куба",
    "KW", "Кувейт",
    "LA", "Лаос",
    "LV", "Латвия",
    "LS", "Лесото",
    "LR", "Либерия",
    "LB", "Ливан",
    "LY", "Ливия",
    "LT", "Литва",
    "LI", "Лихтенштейн",
    "LU", "Люксембург",
    "MU", "Маврикий",
    "MR", "Мавритания",
    "MG", "Мадагаскар",
    "YT", "Майот",
    "MO", "Макао",
    "MK", "Македония",
    "MW", "Малави",
    "MY", "Малайзия",
    "ML", "Мали",
    "MV", "Мальдивы",
    "MT", "Мальта",
    "MA", "Марокко",
    "MQ", "Мартиника",
    "MH", "Маршалловы острова",
    "MX", "Мексика",
    "MZ", "Мозамбик",
    "MD", "Молдавия",
    "MC", "Монако",
    "MN", "Монголия",
    "MS", "Монсеррат",
    "MM", "Мьянма",
    "NA", "Намибия",
    "NR", "Науру",
    "NP", "Непал",
    "NE", "Нигер",
    "NG", "Нигерия",
    "AN", "Нидерландские Антильские острова",
    "NL", "Нидерланды",
    "NI", "Никарагуа",
    "NU", "Ниуэ",
    "NC", "Новая Каледония",
    "NZ", "Новая Зеландия",
    "NO", "Норвегия",
    "AE", "Объединённые Арабские Эмираты",
    "OM", "Оман",
    "CX", "Остров Рождества",
    "CK", "Острова Кука",
    "HM", "Острова Хирд и Макдональд",
    "PK", "Пакистан",
    "PW", "Палау",
    "PS", "Палестинская автономия",
    "PA", "Панама",
    "PG", "Папуа-Новая Гвинея",
    "PY", "Парагвай",
    "PE", "Перу",
    "PN", "Питкэрн",
    "PL", "Польша",
    "PT", "Португалия",
    "PR", "Пуэрто-Рико",
    "CG", "Республика Конго",
    "RE", "Реюньон",
    "RU", "Россия",
    "RW", "Руанда",
    "RO", "Румыния",
    "US", "США",
    "SV", "Сальвадор",
    "WS", "Самоа",
    "SM", "Сан-Марино",
    "ST", "Сан-Томе и Принсипи",
    "SA", "Саудовская Аравия",
    "SZ", "Свазиленд",
    "SJ", "Свальбард и Ян Майен",
    "MP", "Северные Марианские острова",
    "SC", "Сейшелы",
    "SN", "Сенегал",
    "VC", "Сент-Винсент и Гренадины",
    "KN", "Сент-Китс и Невис",
    "LC", "Сент-Люсия",
    "PM", "Сент-Пьер и Микелон",
    "CS", "Сербия и Черногория",
    "SG", "Сингапур",
    "SY", "Сирия",
    "SK", "Словакия",
    "SI", "Словения",
    "SB", "Соломоновы острова",
    "SO", "Сомали",
    "SD", "Судан",
    "SR", "Суринам",
    "SL", "Сьерра-Леоне",
    "SU", "СССР",
    "TJ", "Таджикистан",
    "TH", "Таиланд",
    "TW", "Тайвань",
    "TZ", "Танзания",
    "TG", "Того",
    "TK", "Токелау",
    "TO", "Тонга",
    "TT", "Тринидад и Тобаго",
    "TV", "Тувалу",
    "TN", "Тунис",
    "TM", "Туркменистан",
    "TR", "Турция",
    "UG", "Уганда",
    "UZ", "Узбекистан",
    "UA", "Украина",
    "UY", "Уругвай",
    "FO", "Фарерские острова",
    "FM", "Федеративные Штаты Микронезии",
    "FJ", "Фиджи",
    "PH", "Филиппины",
    "FI", "Финляндия",
    "FK", "Фолклендские острова",
    "FR", "Франция",
    "GF", "Французская Гвиана",
    "PF", "Французская Полинезия",
    "TF", "Французские Южные территории",
    "HR", "Хорватия",
    "CF", "Центрально-Африканская Республика",
    "TD", "Чад",
    "CZ", "Чехия",
    "CL", "Чили",
    "CH", "Швейцария",
    "SE", "Швеция",
    "LK", "Шри-Ланка",
    "EC", "Эквадор",
    "GQ", "Экваториальная Гвинея",
    "ER", "Эритрея",
    "EE", "Эстония",
    "ET", "Эфиопия",
    "ZA", "ЮАР",
    "KR", "Южная Корея",
    "GS", "Южная Георгия и Южные Сандвичевы острова",
    "JM", "Ямайка",
    "JP", "Япония",
    "BV", "остров Буве",
    "NF", "остров Норфолк",
    "SH", "остров Святой Елены",
    "TC", "острова Тёркс и Кайкос",
    "WF", "острова Уоллис и Футура",
    NULL};

char *countries_eng[] = {
    "AD", "Andorra",
    "AE", "United Arab Emirates",
    "AF", "Afghanistan",
    "AG", "Antigua and Barbuda",
    "AI", "Anguilla",
    "AL", "Albania",
    "AM", "Armenia",
    "AN", "Netherlands Antilles",
    "AO", "Angola",
    "AQ", "Antarctica",
    "AR", "Argentina",
    "AS", "American Samoa",
    "AT", "Austria",
    "AU", "Australia",
    "AW", "Aruba",
    "AX", "Åland Islands",
    "AZ", "Azerbaijan",
    "BA", "Bosnia and Herzegovina",
    "BB", "Barbados",
    "BD", "Bangladesh",
    "BE", "Belgium",
    "BF", "Burkina Faso",
    "BG", "Bulgaria",
    "BH", "Bahrain",
    "BI", "Burundi",
    "BJ", "Benin",
    "BM", "Bermuda",
    "BN", "Brunei Darussalam",
    "BO", "Bolivia",
    "BR", "Brazil",
    "BS", "Bahamas",
    "BT", "Bhutan",
    "BV", "Bouvet Island",
    "BW", "Botswana",
    "BY", "Belarus",
    "BZ", "Belize",
    "CA", "Canada",
    "CC", "Cocos (Keeling) Islands",
    "CD", "Congo, the Democratic Republic of the",
    "CF", "Central African Republic",
    "CG", "Congo",
    "CH", "Switzerland",
    "CI", "Côte d\"Ivoire",
    "CK", "Cook Islands",
    "CL", "Chile",
    "CM", "Cameroon",
    "CN", "China",
    "CO", "Colombia",
    "CR", "Costa Rica",
    "CU", "Cuba",
    "CV", "Cape Verde",
    "CX", "Christmas Island",
    "CY", "Cyprus",
    "CZ", "Czech Republic",
    "DE", "Germany",
    "DJ", "Djibouti",
    "DK", "Denmark",
    "DM", "Dominica",
    "DO", "Dominican Republic",
    "DZ", "Algeria",
    "EC", "Ecuador",
    "EE", "Estonia",
    "EG", "Egypt",
    "EH", "Western Sahara",
    "ER", "Eritrea",
    "ES", "Spain",
    "ET", "Ethiopia",
    "FI", "Finland",
    "FJ", "Fiji",
    "FK", "Falkland Islands (Malvinas)",
    "FM", "Micronesia, Federated States of",
    "FO", "Faroe Islands",
    "FR", "France",
    "GA", "Gabon",
    "GB", "United Kingdom",
    "GD", "Grenada",
    "GE", "Georgia",
    "GF", "French Guiana",
    "GG", "Guernsey",
    "GH", "Ghana",
    "GI", "Gibraltar",
    "GL", "Greenland",
    "GM", "Gambia",
    "GN", "Guinea",
    "GP", "Guadeloupe",
    "GQ", "Equatorial Guinea",
    "GR", "Greece",
    "GS", "South Georgia and the South Sandwich Islands",
    "GT", "Guatemala",
    "GU", "Guam",
    "GW", "Guinea-Bissau",
    "GY", "Guyana",
    "HK", "Hong Kong",
    "HM", "Heard Island and McDonald Islands",
    "HN", "Honduras",
    "HR", "Croatia",
    "HT", "Haiti",
    "HU", "Hungary",
    "ID", "Indonesia",
    "IE", "Ireland",
    "IL", "Israel",
    "IM", "Isle of Man",
    "IN", "India",
    "IO", "British Indian Ocean Territory",
    "IQ", "Iraq",
    "IR", "Iran, Islamic Republic of",
    "IS", "Iceland",
    "IT", "Italy",
    "JE", "Jersey",
    "JM", "Jamaica",
    "JO", "Jordan",
    "JP", "Japan",
    "KE", "Kenya",
    "KG", "Kyrgyzstan",
    "KH", "Cambodia",
    "KI", "Kiribati",
    "KM", "Comoros",
    "KN", "Saint Kitts and Nevis",
    "KP", "Korea, Democratic People\"s Republic of",
    "KR", "Korea, Republic of",
    "KW", "Kuwait",
    "KY", "Cayman Islands",
    "KZ", "Kazakhstan",
    "LA", "Lao People\"s Democratic Republic",
    "LB", "Lebanon",
    "LC", "Saint Lucia",
    "LI", "Liechtenstein",
    "LK", "Sri Lanka",
    "LR", "Liberia",
    "LS", "Lesotho",
    "LT", "Lithuania",
    "LU", "Luxembourg",
    "LV", "Latvia",
    "LY", "Libyan Arab Jamahiriya",
    "MA", "Morocco",
    "MC", "Monaco",
    "MD", "Moldova, Republic of",
    "ME", "Montenegro",
    "MG", "Madagascar",
    "MH", "Marshall Islands",
    "MK", "Macedonia, the former Yugoslav Republic of",
    "ML", "Mali",
    "MM", "Myanmar",
    "MN", "Mongolia",
    "MO", "Macao",
    "MP", "Northern Mariana Islands",
    "MQ", "Martinique",
    "MR", "Mauritania",
    "MS", "Montserrat",
    "MT", "Malta",
    "MU", "Mauritius",
    "MV", "Maldives",
    "MW", "Malawi",
    "MX", "Mexico",
    "MY", "Malaysia",
    "MZ", "Mozambique",
    "NA", "Namibia",
    "NC", "New Caledonia",
    "NE", "Niger",
    "NF", "Norfolk Island",
    "NG", "Nigeria",
    "NI", "Nicaragua",
    "NL", "Netherlands",
    "NO", "Norway",
    "NP", "Nepal",
    "NR", "Nauru",
    "NU", "Niue",
    "NZ", "New Zealand",
    "OM", "Oman",
    "PA", "Panama",
    "PE", "Peru",
    "PF", "French Polynesia",
    "PG", "Papua New Guinea",
    "PH", "Philippines",
    "PK", "Pakistan",
    "PL", "Poland",
    "PM", "Saint Pierre and Miquelon",
    "PN", "Pitcairn",
    "PR", "Puerto Rico",
    "PS", "Palestinian Territory, Occupied",
    "PT", "Portugal",
    "PW", "Palau",
    "PY", "Paraguay",
    "QA", "Qatar",
    "RE", "Réunion",
    "RO", "Romania",
    "RS", "Serbia",
    "RU", "Russian Federation",
    "RW", "Rwanda",
    "SA", "Saudi Arabia",
    "SB", "Solomon Islands",
    "SC", "Seychelles",
    "SD", "Sudan",
    "SE", "Sweden",
    "SG", "Singapore",
    "SH", "Saint Helena",
    "SI", "Slovenia",
    "SJ", "Svalbard and Jan Mayen",
    "SK", "Slovakia",
    "SL", "Sierra Leone",
    "SM", "San Marino",
    "SN", "Senegal",
    "SO", "Somalia",
    "SR", "Suriname",
    "ST", "Sao Tome and Principe",
    "SV", "El Salvador",
    "SY", "Syrian Arab Republic",
    "SZ", "Swaziland",
    "TC", "Turks and Caicos Islands",
    "TD", "Chad",
    "TF", "French Southern Territories",
    "TG", "Togo",
    "TH", "Thailand",
    "TJ", "Tajikistan",
    "TK", "Tokelau",
    "TL", "Timor-Leste",
    "TM", "Turkmenistan",
    "TN", "Tunisia",
    "TO", "Tonga",
    "TR", "Turkey",
    "TT", "Trinidad and Tobago",
    "TV", "Tuvalu",
    "TW", "Taiwan, Province of China",
    "TZ", "Tanzania, United Republic of",
    "UA", "Ukraine",
    "UG", "Uganda",
    "UM", "United States Minor Outlying Islands",
    "US", "United States",
    "UY", "Uruguay",
    "UZ", "Uzbekistan",
    "VA", "Holy See (Vatican City State)",
    "VC", "Saint Vincent and the Grenadines",
    "VE", "Venezuela",
    "VG", "Virgin Islands, British",
    "VI", "Virgin Islands, U.S.",
    "VN", "Viet Nam",
    "VU", "Vanuatu",
    "WF", "Wallis and Futuna",
    "WS", "Samoa",
    "YE", "Yemen",
    "YT", "Mayotte",
    "ZA", "South Africa",
    "ZM", "Zambia",
    "ZW", "Zimbabwe",
    NULL};

int LEVEL_SIZE[] = {8,8,4,4,3,3,2,0};

unsigned long first_xor_code;




void cngeoip_init() {
    int i, left;

    first_xor_code = 1;
    for ( i=0, left=32; i<8; i++ ) {
	first_xor_code <<= LEVEL_SIZE[i];
	first_xor_code += left;
	first_xor_code = ((first_xor_code >> 11) & 0x001fffff) + ( first_xor_code << 11);
	left -= LEVEL_SIZE[i];
    }
}


void cngeoip_to1251(char *str) {
    unsigned char *fp, *tp;
    for ( fp=(unsigned char*)str, tp=(unsigned char*)str; *fp; fp++, tp++) {
	if ( *fp < 0x80 ) {
	    *tp = *fp;
	}
	else {
	    if ( fp[0] == 0xd0 ) *tp = fp[1] + 0x30;
	    else if ( *fp == 0xd1 ) *tp = fp[1] + 0x70;
	    else *tp = '_';
	    fp++;
	}
    }
    *tp = 0;
}


int cngeoip_str2ip(char *ipstr, unsigned long *ip) {
//
//	returns:
//		-1 if one of octets is more than 255
//		-2 if symbol other than 0-9 and dot is detected
//
    int i;
    *ip = 0;
    int octet = 0;
    
    for ( i=0; ipstr[i]; i++ ) {
	if ( ipstr[i]>='0' && ipstr[i]<='9' ) {
	    octet *= 10;
	    octet += ipstr[i] - '0';
	    if ( octet > 255 ) {
		return -1;
	    }
	}
	else if ( ipstr[i] == '.' ) {
	    *ip <<= 8;
	    *ip += octet;
	    octet = 0;
	}
	else return -2;
    }
    *ip <<= 8;
    *ip += octet;

    return 0;
}


int cngeoip_lookup(char *dbfile, struct cngeoip_result *res) {
    FILE *fp;
    int shift, l, length, i;
    unsigned long offset, index, tell, unp, gxor;
    unsigned char data[4];
    char info[CNGEOIP_MAX_INFO_LEN];
    char *next, *curr;
    char **ccp;

    res->city_eng[0] = 0;
    res->city_rus[0] = 0;
    res->country_code[0] = 0;
    res->country_eng[0] = 0;
    res->country_rus[0] = 0;
    res->region_eng[0] = 0;
    res->region_rus[0] = 0;
    res->geo_lon = 0;
    res->geo_lat = 0;
    fp = fopen(dbfile, "r");
    if ( !fp )
	return -1;

    shift = 32;
    offset = 0;
    for ( l=0; LEVEL_SIZE[l]; l++ ) {
	shift -= LEVEL_SIZE[l];
	index = ((res->ip>>shift)) & ((1<<LEVEL_SIZE[l])-1);
	tell = offset+index*4;
	fseek(fp, tell, 0);
	fread(data, 4, 1, fp);
	unp = data[0] + (data[1]<<8) + (data[2]<<16) + (data[3]<<24);
	offset = unp ^ first_xor_code ^ tell;
	if ( offset & 0x80000000 ) {
	    tell = offset & 0x7fffffff;
	    fseek(fp, tell, 0);
	    fread(data, 2, 1, fp);
	    unp = data[0] + (data[1]<<8);
	    length = ( unp ^ first_xor_code ^ tell ) &0xffff;
	    tell += 2;
	    if ( length > 0 ) {
		if ( length > CNGEOIP_MAX_INFO_LEN-1 )
		    length = CNGEOIP_MAX_INFO_LEN-1;
		fread(info, length, 1, fp);
		info[length] = 0;
		gxor = tell ^ first_xor_code;
		for ( i=0; i<length; i++ ) {
		    info[i] = info[i] ^ gxor;
		    gxor = ( (gxor >> 3) &0x1fffffff) ^ ( (gxor & 0x1fffffff) << 3);
		}

#ifdef CNGEOIP_USE_1251
cngeoip_to1251(info);
#endif

		curr = info;
		for( i=0; 1; i++ ) {
		    next = strchr(curr, '/');
		    if ( next ) next[0] = 0;
		    switch ( i ) {
			case 0:
			    if ( next - curr > CNGEOIP_STR_LEN-1 )
				curr[CNGEOIP_STR_LEN-1] = 0;
			    strcpy(res->city_rus, curr);
			    break;
			case 1:
			    if ( next - curr > CNGEOIP_STR_LEN-1 )
				curr[CNGEOIP_STR_LEN-1] = 0;
			    strcpy(res->city_eng, curr);
			    break;
			case 2:
			    if ( next - curr > 2 )
				curr[2] = 0;
			    strcpy(res->country_code, curr);
			    for ( ccp=countries_rus; *ccp; ccp += 2 ) {
				if ( strcmp(ccp[0], res->country_code) == 0 ) {
				    strcpy(res->country_rus, ccp[1]);
				    break;
				}
			    }
			    for ( ccp=countries_eng; *ccp; ccp += 2 ) {
				if ( strcmp(ccp[0], res->country_code) == 0 ) {
				    strcpy(res->country_eng, ccp[1]);
				    break;
				}
			    }
			    break;
			case 3:
			    res->geo_lon = atof(curr);
			    break;
			case 4:
			    res->geo_lat = atof(curr);
			    break;
			case 5:
			    if ( next - curr > CNGEOIP_STR_LEN-1 )
				curr[CNGEOIP_STR_LEN-1] = 0;
			    strcpy(res->region_rus, curr);
			    break;
			case 6:
			    if ( next - curr > CNGEOIP_STR_LEN-1 )
				curr[CNGEOIP_STR_LEN-1] = 0;
			    strcpy(res->region_eng, curr);
			    break;
		    }
		    if ( next )
			curr = next+1;
		    else
			break;
		}
#ifdef CNGEOIP_USE_1251
			    cngeoip_to1251(res->country_eng);
			    cngeoip_to1251(res->country_rus);
#endif
	    }
	    else
		info[0] = 0;
	    break;
	}
    }

    fclose(fp);

    return 0;
}

