#include <stdio.h>
#include "cngeoip.h"


#define DBFILE "../cngeoip.dat"


int main(int argc, char** argv) {
    int i;
    unsigned long ip;
    struct cngeoip_result res;

    if ( argc == 1 ) {
	printf("Usage: %s [ip] ...\n", argv[0]);
	return -1;
    }

    cngeoip_init();

    for ( i=1; i<argc; i++ ) {
	printf("Processing ip: %s...\n", argv[i]);
	if ( cngeoip_str2ip(argv[i], &res.ip) ) {
	    printf("Ip address format error!\n");
	    continue;
	}
	cngeoip_lookup(DBFILE, &res);
	printf("Result: (%s/%s/%s/%1.4f/%1.4f/%s/%s/%s/%s)\n", res.city_eng, res.city_rus, res.country_code, res.geo_lon, res.geo_lat, res.country_eng, res.country_rus, res.region_eng, res.region_rus);
    }
    
    return 0;
}
